
local _, TzDR = ...

-----------
-- Round --
-----------
local function Round( _value )
	return floor( _value + 0.5 )
end

--------------------
-- TzRares_OnLoad --
--------------------
function TzRares_OnLoad( _self )
	TzDR.frame = _self
end

--------------------------
-- WorldMapFrame_Update --
--------------------------
hooksecurefunc( "WorldMapFrame_Update", function()
	TzRaresIcons_Hide()

----------------------------------------------------------------
-- Pandaria Rares

	if TzRaresOptions.pandariarares_show then
		db = TzDR.db[ "PandariaRares" ]

		for _, entry in ipairs( db ) do
			if GetCurrentMapAreaID() == entry.areaID then
				local questCompleted = false

				for _, questID in ipairs( entry.questIDs ) do
					if questID ~= 0 and IsQuestFlaggedCompleted( questID ) then
						questCompleted = true
					end
				end

				if not questCompleted then
					for _, coord in ipairs( entry.coords ) do
						local icon = TzRaresIcons_Get( "interface/minimap/objecticons", 46, TzRaresOptions.pandariarares_scale, 1.0, 0.25, 0.25, 1.0 )
						local x = Round( ( coord[ 1 ] / 100 ) * WorldMapDetailFrame:GetWidth() )	-- Convert from TomTom
						local y = Round( ( coord[ 2 ] / 100 ) * WorldMapDetailFrame:GetHeight() )	-- Convert from TomTom
						local offset = TzRaresOptions.pandariarares_scale / 32.0

						icon.frame:SetPoint( "CENTER", WorldMapDetailFrame, "TOPLEFT", x - offset, -y - offset )
						icon.frame:Show()

						icon.image.text = format( "%s", entry.name )
						icon.image:SetPoint( "CENTER", WorldMapDetailFrame, "TOPLEFT", x, -y )
						icon.image:Show()
					end
				end
			end
		end
	end

----------------------------------------------------------------
-- Draenor Rares

	if TzRaresOptions.draenorrares_show then
		db = TzDR.db[ "DraenorRares" ]

		for _, entry in ipairs( db ) do
			if GetCurrentMapAreaID() == entry.areaID then
				local questCompleted = false

				for _, questID in ipairs( entry.questIDs ) do
					if questID ~= 0 and IsQuestFlaggedCompleted( questID ) then
						questCompleted = true
					end
				end

				if not questCompleted then
					for _, coord in ipairs( entry.coords ) do
						local icon = TzRaresIcons_Get( "interface/minimap/objecticons", 46, TzRaresOptions.draenorrares_scale, 1.0, 0.25, 0.25, 1.0 )
						local x = Round( ( coord[ 1 ] / 100 ) * WorldMapDetailFrame:GetWidth() )	-- Convert from TomTom
						local y = Round( ( coord[ 2 ] / 100 ) * WorldMapDetailFrame:GetHeight() )	-- Convert from TomTom
						local offset = TzRaresOptions.draenorrares_scale / 32.0

						icon.frame:SetPoint( "CENTER", WorldMapDetailFrame, "TOPLEFT", x - offset, -y - offset )
						icon.frame:Show()

						icon.image.text = format( "%s", entry.name )
						icon.image:SetPoint( "CENTER", WorldMapDetailFrame, "TOPLEFT", x, -y )
						icon.image:Show()
					end
				end
			end
		end
	end
end )
